"""
				Some more difficult algorithms to refer back to if necessary
"""

: constant create , does> @ ;			# Constant creation boilerplate
" ['\n'] " eval fset slice constant nl		# Python new line character e.g. " This is " nl + " a test. " + .
: var create 1 allot ;  			# Variable creation boilerplate
var recordset

						# Looping examples

# Upwards iterator

3 0 begin dup . 1 + over over - 0 = until drop drop /n

# Upwards nested iterator.. Note the extra drop on the internal loop

3 0 begin dup 
	12 0 begin dup . 1 + over over - 0 = until drop drop drop /n
1 + over over - 0 = until drop drop /n 

# Downwards iterator

3 begin dup . 1 - dup 0 = until drop /n

# Downwards nested iterator.. Note the extra drop on the internal loop

3 begin dup 
	9 begin dup . 1 - dup 0 = until drop drop /n
1 - dup 0 = until drop /n

						# An Isectd recordset is assigned to a variable

" [[{'name':'ID','type':'i','null':0,'width':4},{'name':'MSGID','type':'i','null':0,'width':4},{'name':'FKISSUES','type':'i','null':0,'width':4},{'name':'FKPEOPLE','type':'i','null':0,'width':4},{'name':'BODY','type':'s','null':1,'width':32765},{'name':'STATUS','type':'i','null':0,'width':4},{'name':'LAST_ACTIVITY','type':'d','null':0,'width':8}],
[[          4,          4,          3,          6,'What would we talk about?',         30,'2018-06-02 15:10:07.0000'],
[          6,          6,          3,          6,'I need to keep going with this software.',         30,'2018-06-07 21:01:40.0000'],
[          7,          7,          3,          6,'Another note...',         30,'2018-06-19 11:16:40.0000']]] " recordset !


"""
	Objects would require four new builtin words operating on a dictionary of environments comprising 
	heap, heapNext, rDict, cStack. ds however would be shared. There are two stages, defining the class and
	instantiating the object. This design could also be used for round robin threading.

	The primary dictionary and primary heap would also have to be shared. The code would search the current 
	dictionary first and if the word cannot be located it would search the primary dictionary.
"""

1. ( class -- ) new - take the name of the class and make a new environment with the class name as the dictionary label,
		saving the primary environment first (call the primary environment... main?)

2. Define words and create variables and constants as required which will be defined in the new environment.

Finish with    	: class create , does> @ plus words from above in a switch statement including return and destroy ;
	    	which means the name of the object is the first item pushed onto the stack and can be used by the 
		following two commands

3. After defining the class you would call return separately using the class name to go back to the primary environment.

( object -- )		return - reverts to the primary environment retaining the object environment
( object -- )		destroy - reverts to the primary environment destroying the object environment

4. ( object class -- )	object - copies the class environment to a new environment named object which becomes the
			current environment.

5. Immediately after calling object you would execute the : class create , does> ; statement using the same object name.



